import { CalculatorType } from "../../src/compute-node";
import { MacroRugo } from "../../src/macrorugo/macrorugo";
import { Props } from "../../src/props";
import { Session } from "../../src/session";

let m154: MacroRugo;
const aQ154: number[] = [0.285749, 0.300390, 0.315000, 0.329554, 0.344031, 0.358410, 0.372674, 0.407595];
let i154: number;
describe("Class MacroRugo: ", () => {
    describe("jalhyd #154", () => {
        it("Check values of resolveQ", () => {
            m154 = Session.getInstance().createNub(
                new Props({ calcType: CalculatorType.MacroRugo })
            ) as MacroRugo;
            m154.prms.Ks.v = 0.1;
            m154.prms.Cd0.v = 1;
            m154.prms.Y.v = 0.3;
            // tslint:disable-next-line: no-string-literal
            m154["setFlowType"]();
            const aQ: number[] = [0.105312, 0.061355, 0.228021];
            for (let i = 0; i < aQ.length; i++) {
                m154.prms.Q.v = 0.2 + i * 0.05;
                // tslint:disable-next-line:no-string-literal
                expect(Math.abs(m154["resolveQ"]())).toBeCloseTo(aQ[i], 5);
            }
        });
    });
    describe("jalhyd #154", () => {
        beforeAll(() => {
            m154 = Session.getInstance().createNub(
                new Props({ calcType: CalculatorType.MacroRugo })
            ) as MacroRugo;
            m154.prms.Ks.setValue(0.1);
            m154.prms.Cd0.setValue(1);
            m154.prms.Y.setValues(0.34, 0.41, 0.01);
            m154.calculatedParam = m154.prms.Q;
            m154.CalcSerie();
            i154 = 0;
        });
        afterEach(() => {
            i154++;
        });
        for (let i = 0; i < aQ154.length; i++) {
            it(`Q(Y=${0.34 + i * 0.01}) should be ${aQ154[i]}`, () => {
                expect(m154.result.resultElements[i].vCalc).toBeCloseTo(aQ154[i154], 4);
            });
        }
    });
});
